﻿Option Strict On

Public Class Form1
    Private _originalLocation As New Point
    Private _originalSize As Size = Nothing
    Private _scale As Single = 1
    Private _scaleDelta As Single = 0.0001
    Dim l As Rectangle
    Dim r As Rectangle

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load

        PictureBox1.Size = Panel1.Size
        PictureBox1.SizeMode = PictureBoxSizeMode.Zoom
        PictureBox1.Image = Bitmap.FromFile("D:\Medien\SJCAM\Photo\2016_0926_152202_001.JPG")
        _originalLocation = PictureBox1.Location

        l = New Rectangle(PictureBox1.Location.X,
                          PictureBox1.Location.Y,
                          PictureBox1.Width \ 2,
                          PictureBox1.Height)
        r = New Rectangle(PictureBox1.Location.X + (PictureBox1.Width \ 2),
                          PictureBox1.Location.Y,
                          PictureBox1.Width \ 2,
                          PictureBox1.Height)

        If PictureBox1.Image IsNot Nothing Then
            PictureBox1.Size = Panel1.Size
            _originalSize = Panel1.Size
        End If

    End Sub

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click

        _scaleDelta = CSng(Math.Sqrt(PictureBox1.Width * PictureBox1.Height) * 0.0001)
        _scale += _scaleDelta

        PictureBox1.Size = New Size(CInt(Math.Round(_originalSize.Width * _scale)),
                                    CInt(Math.Round(_originalSize.Height * _scale)))
        PictureBox1.Location = New Point(_originalLocation.X - ((PictureBox1.Width - Panel1.Width) \ 2),
                                         _originalLocation.Y - ((PictureBox1.Height - Panel1.Height) \ 2))

        l = New Rectangle(PictureBox1.Location.X,
                          PictureBox1.Location.Y,
                          PictureBox1.Width \ 2,
                          PictureBox1.Height)
        r = New Rectangle(PictureBox1.Location.X + (PictureBox1.Width \ 2),
                          PictureBox1.Location.Y,
                          PictureBox1.Width \ 2,
                          PictureBox1.Height)

    End Sub

    Private Sub Button3_Click(sender As Object, e As EventArgs) Handles Button3.Click

        _scaleDelta = CSng(Math.Sqrt(PictureBox1.Width * PictureBox1.Height) * 0.0001)
        _scale -= _scaleDelta

        PictureBox1.Size = New Size(CInt(Math.Round(_originalSize.Width * _scale)),
                                    CInt(Math.Round(_originalSize.Height * _scale)))
        PictureBox1.Location = New Point(_originalLocation.X - ((PictureBox1.Width - Panel1.Width) \ 2),
                                         _originalLocation.Y - ((PictureBox1.Height - Panel1.Height) \ 2))

        l = New Rectangle(PictureBox1.Location.X,
                  PictureBox1.Location.Y,
                  PictureBox1.Width \ 2,
                  PictureBox1.Height)
        r = New Rectangle(PictureBox1.Location.X + (PictureBox1.Width \ 2),
                          PictureBox1.Location.Y,
                          PictureBox1.Width \ 2,
                          PictureBox1.Height)

    End Sub

    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles Button2.Click

        Dim mybrush As Brush = Brushes.Blue
        Dim mybrush_r As Brush = Brushes.Red

        PictureBox1.CreateGraphics.FillRectangle(mybrush, l)
        PictureBox1.CreateGraphics.FillRectangle(mybrush_r, r)

    End Sub

End Class